/* ***************************************************************** */
/*        SCIENTIFIC VISUALIZATION: Ocean Floor Dialog BEGIN         */
/* ***************************************************************** */
/* Programmer:	Du Xiao-song
 * Date:	Aug.25.95
 * Dept:	EE
 * Office:	ERC 314
 * Phone:	601-325-2080(Office)
 *		601-324-0237(Home)
 * Email:	xsdu@ERC.MsState.edu 
 * Compile with:
 * CC -ansi -w -I/usr/local/xmt Contour.c Font.c View.c -o View -L/usr/local/xmt -lXmt -lXm -lXt -lX11 -lGL -lGLU -lGLw
 */
#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/ScrolledW.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/Frame.h>
#include <Xm/Scale.h>
#include <Xm/LabelG.h>
#include <Xm/DialogS.h>
#include <Xm/PanedW.h>
#include <Xm/TextF.h>

#include "FlowView.h"
#include "Font.h"
#include "Dialog.h"

#include <string.h>


/* ***************************************************************** */
/*                          GetTopShell Begin                        */
/* ***************************************************************** */
Widget GetTopShell(Widget w)
{ /* GetTopShell begin */
    while (w && !XtIsWMShell(w))
          w=XtParent(w);
    return(w);
} /* GetTopShell end   */
/* ***************************************************************** */
/*                          GetTopShell End                          */
/* ***************************************************************** */

/* ***************************************************************** */
/*                              Setup Begin                          */
/* ***************************************************************** */
void Setup(Widget w, XtPointer data, XtPointer callData)
{ /* Setup begin */ 
    Widget	dialog, pane, form, rc, label, ActionArea;
    Widget	EditYear, EditTime, EditLayer;
    Widget	EditXs, EditYs, EditXlength, EditYwidth;
    Widget	OKButton, CancelButton;
    XmString	string;
 
    bYear=Year;
    bLayer=LayerPtr;
    bTime=TimeSteps;
    bXsize=XSIZE; 
    bYsize=YSIZE;
    bXstart=XStart;
    bYstart=YStart;
    
    dialog=XtVaCreatePopupShell("Setup", 
		       xmDialogShellWidgetClass, GetTopShell(w), 
		       XmNdeleteResponse,	 XmDESTROY, 
		       NULL);
    pane=XtVaCreateManagedWidget("pane", 
                       xmPanedWindowWidgetClass, dialog, 
		       XmNsashWidth,		 1, 
		       XmNsashHeight,		 1, 
		       XmNwidth,	         300, 
		       XmNheight,	         450, 		       
		       NULL);
    rc=XtVaCreateManagedWidget("control", 
                       xmFormWidgetClass,        pane,
		       XmNwidth,	         300, 
		       XmNheight,	         250, 
		       NULL);

/* Edit Year */
    string=XmStringCreateSimple("Year:");
    XtVaCreateManagedWidget("label1", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   7, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  19,
		       NULL);
    XmStringFree(string);
     
    EditYear=XtVaCreateManagedWidget("EditYear", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   7, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  19,
		       NULL);
/* Edit X Start */
    string=XmStringCreateSimple("X Start:");
    XtVaCreateManagedWidget("label4", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   20, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  32,
		       NULL);
    XmStringFree(string);
     
    EditXs=XtVaCreateManagedWidget("EditXs", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   20, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  32,
		       NULL);
/* Edit Y Start */
    string=XmStringCreateSimple("Y Start:");
    XtVaCreateManagedWidget("label5", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   33, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  45,
		       NULL);
    XmStringFree(string);
     
    EditYs=XtVaCreateManagedWidget("EditYs", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   33, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  45,
		       NULL);
/* Edit X Length */
    string=XmStringCreateSimple("X Length:");
    XtVaCreateManagedWidget("label6", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   46, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  58,
		       NULL);
    XmStringFree(string);
     
    EditXlength=XtVaCreateManagedWidget("EditXlength", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   46, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  58,
		       NULL);
/* Edit Y Width */
    string=XmStringCreateSimple("Y Width:");
    XtVaCreateManagedWidget("label7", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   59, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  71,
		       NULL);
    XmStringFree(string);
     
    EditYwidth=XtVaCreateManagedWidget("EditYwidth", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   59, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  71,
		       NULL);
    
    ActionArea=XtVaCreateManagedWidget("form2", 
                       xmFormWidgetClass,  pane,
		       XmNwidth,	   300, 
		       XmNheight,	   50, 
		       XmNskipAdjust,	   True,
		       NULL);
		       
    OKButton=XtVaCreateManagedWidget("OK", 
		       xmPushButtonWidgetClass, ActionArea,  
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   10, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   40, 
		       XmNtopAttachment,   XmATTACH_FORM, 
		       XmNbottomAttachment,XmATTACH_FORM, 
		       NULL);
    CancelButton=XtVaCreateManagedWidget("Cancel", 
		       xmPushButtonWidgetClass, ActionArea,  
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   60, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   90, 
		       XmNtopAttachment,   XmATTACH_FORM, 
		       XmNbottomAttachment,XmATTACH_FORM, 
		       NULL);

    XtAddCallback(EditYear,	XmNactivateCallback, GetYear,	 dialog);
    XtAddCallback(EditXs,	XmNactivateCallback, GetXs,      dialog);
    XtAddCallback(EditYs,	XmNactivateCallback, GetYs,      dialog);
    XtAddCallback(EditXlength,	XmNactivateCallback, GetXlength, dialog);
    XtAddCallback(EditYwidth,	XmNactivateCallback, GetYwidth,  dialog);
		       
    XtAddCallback(OKButton,	XmNactivateCallback, DialogOK,     dialog);
    XtAddCallback(CancelButton,	XmNactivateCallback, DialogCancel, dialog);
    XtPopup(dialog, XtGrabNone);
		       
} /* Setup end   */
/* ***************************************************************** */
/*                                Setup End                          */
/* ***************************************************************** */

/* ***************************************************************** */
/*                               GetYear Begin                       */
/* ***************************************************************** */
static void GetYear(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetYear begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
       bYear=(int)strtol(text, &end, 10);
    XtFree(text);
} /* GetYear end   */
/* ***************************************************************** */
/*                                GetYear End                        */
/* ***************************************************************** */


/* ***************************************************************** */
/*                               GetXs Begin                         */
/* ***************************************************************** */
static void GetXs(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetXs begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
       bXstart=(int)strtol(text, &end, 10);
    XtFree(text);
} /* GetXs end   */
/* ***************************************************************** */
/*                                GetXs End                          */
/* ***************************************************************** */

/* ***************************************************************** */
/*                               GetYs Begin                         */
/* ***************************************************************** */
static void GetYs(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetYs begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
       bYstart=(int)strtol(text, &end, 10);
    XtFree(text);
} /* GetYs end   */
/* ***************************************************************** */
/*                                GetYs End                          */
/* ***************************************************************** */

/* ***************************************************************** */
/*                             GetXlength Begin                      */
/* ***************************************************************** */
static void GetXlength(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetXlength begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
       bXsize=(int)strtol(text, &end, 10);
    XtFree(text);
} /* GetXlength end   */
/* ***************************************************************** */
/*                             GetXlength End                        */
/* ***************************************************************** */

/* ***************************************************************** */
/*                             GetYwidth Begin                       */
/* ***************************************************************** */
static void GetYwidth(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetYwidth begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
       bYsize=(int)strtol(text, &end, 10);
    XtFree(text);
} /* GetYwidth end   */
/* ***************************************************************** */
/*                             GetYwidth End                         */
/* ***************************************************************** */

/* ***************************************************************** */
/*                            DialogOK Begin                         */
/* ***************************************************************** */
static void DialogOK(Widget w, Widget shell, XmAnyCallbackStruct *cbs)
{ /* DialogOK begin */
    XmString	old;

    if ((bYear == 1983) || (bYear == 1984) || (bYear == 1985))
       Year=bYear;
    XSIZE=bXsize; 
    YSIZE=bYsize;
    XStart=bXstart;
    YStart=bYstart;
    XtDestroyWidget(shell);

/* ReLoad data file */
    LoadLayerVelocity(Year, TimeSteps);
    RenderVelocityToFile();
    LineOKFlag=0;
        
    DrawObject();
} /* DialogOK end   */
/* ***************************************************************** */
/*                            DialogOK End                           */
/* ***************************************************************** */

/* ***************************************************************** */
/*                          DialogCancel Begin                       */
/* ***************************************************************** */
static void DialogCancel(Widget w, Widget shell, XmAnyCallbackStruct *cbs)
{ /* DialogCancel begin */
    XtDestroyWidget(shell);
} /* DialogCancel end   */
/* ***************************************************************** */
/*                          DialogCancel End                         */
/* ***************************************************************** */



/* ***************************************************************** */
/*                              Locate Begin                         */
/* ***************************************************************** */
void Locate(Widget w, XtPointer data, XtPointer callData)
{ /* Locate begin */ 
    Widget	dialog, pane, form, rc, label, ActionArea;
    Widget	EditNo, EditX, EditY, EditLayer;
    Widget	OKButton, CancelButton;
    XmString	string;
 
    LocateFlag=0;
    LocateNo=0;
    LocateX=Lines[0].Xi;
    LocateY=Lines[0].Yi;
    LocateLayer=Lines[0].layer;
    
    dialog=XtVaCreatePopupShell("Locate Seed", 
		       xmDialogShellWidgetClass, GetTopShell(w), 
		       XmNdeleteResponse,	 XmDESTROY, 
		       NULL);
    pane=XtVaCreateManagedWidget("pane", 
                       xmPanedWindowWidgetClass, dialog, 
		       XmNsashWidth,		 1, 
		       XmNsashHeight,		 1, 
		       XmNwidth,	         300, 
		       XmNheight,	         300, 		       
		       NULL);
    rc=XtVaCreateManagedWidget("control", 
                       xmFormWidgetClass,        pane,
		       XmNwidth,	         300, 
		       XmNheight,	         250, 
		       NULL);

    string=XmStringCreateSimple("No:");
    XtVaCreateManagedWidget("label1", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   10, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  28,
		       NULL);
    XmStringFree(string);
     
    EditNo=XtVaCreateManagedWidget("EditNo", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   10, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  28,
		       NULL);

    string=XmStringCreateSimple("X:");
    XtVaCreateManagedWidget("label2", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   30, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  48,
		       NULL);
    XmStringFree(string);
     
    EditX=XtVaCreateManagedWidget("EditX", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   30, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  48,
		       NULL);

    string=XmStringCreateSimple("Y:");
    XtVaCreateManagedWidget("label3", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   50, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  68,
		       NULL);
    XmStringFree(string);
     
    EditY=XtVaCreateManagedWidget("EditY", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   50, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  68,
		       NULL);

    string=XmStringCreateSimple("Layer:");
    XtVaCreateManagedWidget("label3", 
		       xmLabelWidgetClass, rc, 
		       XmNlabelString,	   string, 
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   3, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   50, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   70, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  88,
		       NULL);
    XmStringFree(string);
     
    EditLayer=XtVaCreateManagedWidget("Layer", 
                       xmTextFieldWidgetClass, rc,
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   51, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   95, 
		       XmNtopAttachment,   XmATTACH_POSITION, 
		       XmNtopPosition,	   70, 
		       XmNbottomAttachment,XmATTACH_POSITION, 
		       XmNbottomPosition,  88,
		       NULL);

    
    ActionArea=XtVaCreateManagedWidget("form2", 
                       xmFormWidgetClass,  pane,
		       XmNwidth,	   300, 
		       XmNheight,	   50, 
		       XmNskipAdjust,	   True,
		       NULL);
		       
    OKButton=XtVaCreateManagedWidget("OK", 
		       xmPushButtonWidgetClass, ActionArea,  
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   10, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   40, 
		       XmNtopAttachment,   XmATTACH_FORM, 
		       XmNbottomAttachment,XmATTACH_FORM, 
		       NULL);
    CancelButton=XtVaCreateManagedWidget("Cancel", 
		       xmPushButtonWidgetClass, ActionArea,  
		       XmNleftAttachment,  XmATTACH_POSITION, 
		       XmNleftPosition,	   60, 
		       XmNrightAttachment, XmATTACH_POSITION, 
		       XmNrightPosition,   90, 
		       XmNtopAttachment,   XmATTACH_FORM, 
		       XmNbottomAttachment,XmATTACH_FORM, 
		       NULL);
    XtAddCallback(EditNo,	XmNactivateCallback, GetNo,     dialog);
    XtAddCallback(EditX,	XmNactivateCallback, GetX,      dialog);
    XtAddCallback(EditY,	XmNactivateCallback, GetY,	dialog);
    XtAddCallback(EditLayer,	XmNactivateCallback, GetLayer,	dialog);
 		       
    XtAddCallback(OKButton,	XmNactivateCallback, DialogOKLocate,     dialog);
    XtAddCallback(CancelButton,	XmNactivateCallback, DialogCancelLocate, dialog);
    XtPopup(dialog, XtGrabNone);
		       
} /* Locate end   */
/* ***************************************************************** */
/*                                 Locate End                        */
/* ***************************************************************** */

/* ***************************************************************** */
/*                               GetNo Begin                         */
/* ***************************************************************** */
static void GetNo(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetNo begin */
    char    *text=XmTextFieldGetString(w);
    char    *end;
    
    if (strlen(text) != 0)
     { /* if begin */
	LocateFlag=1;
	LocateNo=(int)strtol(text, &end, 10);
     } /* if end   */
    XtFree(text);
} /* GetNo end   */
/* ***************************************************************** */
/*                                GetNo End                          */
/* ***************************************************************** */

/* ***************************************************************** */
/*                                GetX Begin                         */
/* ***************************************************************** */
static void GetX(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetX begin */
    char    *text=XmTextFieldGetString(w);
    char    *end;
    
    if (strlen(text) != 0)
     { /* if begin */
	LocateFlag=1;
	LocateX=(int)strtol(text, &end, 10);
	if (LocateX < 0) LocateX=0;
	if (LocateX >= XRange) LocateX=XRange-1;
     } /* if end   */
    XtFree(text);
} /* GetX end   */
/* ***************************************************************** */
/*                                GetX End                           */
/* ***************************************************************** */

/* ***************************************************************** */
/*                                GetY Begin                         */
/* ***************************************************************** */
static void GetY(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetY begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
     { /* if begin */
	LocateFlag=1;
	LocateY=(int)strtol(text, &end, 10);
	if (LocateY < 0) LocateY=0;
	if (LocateY >= YRange) LocateY=YRange-1;
     } /* if end   */
    XtFree(text);
} /* GetY end   */
/* ***************************************************************** */
/*                                GetY End                           */
/* ***************************************************************** */

/* ***************************************************************** */
/*                           GetLayer Begin                          */
/* ***************************************************************** */
static void GetLayer(Widget w, Widget t, XmAnyCallbackStruct *cbs)
{ /* GetLayer begin */
    char    *end;
    char    *text=XmTextFieldGetString(w);
    
    if (strlen(text) != 0)
     { /* if begin */
	LocateFlag=1;
	LocateLayer=(int)strtol(text, &end, 10);
	if (LocateLayer < 0)  LocateLayer=0;
	if (LocateLayer >= 6) LocateLayer=5;
     } /* if end   */
    XtFree(text);
} /* GetLayer end   */
/* ***************************************************************** */
/*                           GetLayer End                            */
/* ***************************************************************** */

/* ***************************************************************** */
/*                            DialogOKLocate Begin                   */
/* ***************************************************************** */
static void DialogOKLocate(Widget w, Widget shell, XmAnyCallbackStruct *cbs)
{ /* DialogOKLocate begin */
    if (LocateFlag == 1)
     { /* if begin */
	 Lines[LocateNo].Xi=LocateX;
	 Lines[LocateNo].Yi=LocateY;
	 Lines[LocateNo].layer=LocateLayer;
	 Lines[LocateNo].flag=1;	 
     } /* if end   */
    XtDestroyWidget(shell);
} /* DialogOKLocate end   */
/* ***************************************************************** */
/*                            DialogOKLocate End                     */
/* ***************************************************************** */

/* ***************************************************************** */
/*                        DialogCancelLocate Begin                   */
/* ***************************************************************** */
static void DialogCancelLocate(Widget w, Widget shell, XmAnyCallbackStruct *cbs)
{ /* DialogCancelLocate begin */
    XtDestroyWidget(shell);
} /* DialogCancelLocate end   */
/* ***************************************************************** */
/*                        DialogCancelLocate End                     */
/* ***************************************************************** */

/* ***************************************************************** */
/*        SCIENTIFIC VISUALIZATION: Ocean Floor Dialog END           */
/* ***************************************************************** */
