/* ***************************************************************** */
/*	Odd frame: frame t					     */
/*      Even frame: frame at t + tao	  			     */
/* ***************************************************************** */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int	*ImagEven, *ImagOdd, *shiftOut;
float	*IE_F, *IO_F;
int	Xsize;
int	Ysize;
float	Sign;
int 	MINE,MAXE;
int 	MINO,MAXO;

float FD();
float FD_G(); 
float D();

float FD(j,shift)
int j;
float(shift);
{
   int i;
   float tmp;
   int S;
   int Xe;
   tmp = 0.0;
   S = (int) fabs(shift);
   for (i=0; i<Xsize - S; i++) {
       tmp = tmp + IE_F[j*Xsize+i] - IO_F[j*Xsize+i];
   }
   return (tmp);
}

float FD_G(shift, j)
float shift;
int j;
{
   int i;
   int S;
   int Xe,Xn; 
   float tmp;
   tmp = 0.0;
   S = (int) fabs(shift);
   for (i=0; i<Xsize - 1 - S; i++) {
       Xe = j*Xsize + i + S;
       Xn = (j+1)*Xsize + i + S;
       if (shift < 0.0) { 
          tmp = tmp + fabs((IO_F[j*Xsize+i] - IO_F[j*Xsize+i+1]) - 
	   		         (IE_F[Xe] - IE_F[Xe+1])); 
       }
       else {
          tmp = tmp + fabs((IO_F[Xe] - IO_F[Xe+1]) - 
	   		         (IE_F[j*Xsize+i] - IE_F[j*Xsize+i+1])); 
       }
   }
   return (tmp);
}

float D(j, shift, rec_no, E)
int j;
float shift;
int rec_no;
float E;
{   
    float tmp;
    if (rec_no > 10) {
       printf("threshold met\n");
	return (shift);
    }
    if (FD_G(shift, j) < 1/10.) {
	printf("Accuracy Satisfied\n");
	return (shift);
    }
    else {
	tmp = D(j, shift + E*Sign, rec_no + 1, E);
	return(tmp);
    }
}
main (argc, argv)
int	argc;
char *	argv[];
{ /* main begin */
char	EvenImage[100];
char	OddImage[100];
char	ShiftOut[100];
char	*end;
int	InputFlag;
FILE	*FptrE;
FILE	*FptrO;
FILE	*FptrR;
int	i,j;
float	shift;
int     dir;
char	OutImage[100];
char	Buff[30];

	if (argc < 5)
         { /* if begin */
           printf("Usage: Pel -e EvenImage -o OddImage -r Result in shift<Enter>\n");
           exit(0);
         } /* if end   */
        
 	i=0; InputFlag=0;
        while (i < argc)
         { /* while begin */
              if ((strncmp(argv[i],"-e",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(EvenImage,argv[i+1]);
                 i=i+2;
                 InputFlag++;                   
               } /* else if end   */
              else if ((strncmp(argv[i],"-o",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(OddImage,argv[i+1]);
                 i=i+2;   
                 InputFlag++;                
               } /* else if end   */
              else if ((strncmp(argv[i],"-r",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(ShiftOut,argv[i+1]);
                 i=i+2;   
                 InputFlag++;                
               } /* else if end   */
              else if (1)
               { /* else if begin */
                 i++;                  
               } /* else if end   */
                 
         } /* while end   */
        if (InputFlag != 3)
         { /* if begin */
           printf("Bad input!\n");
           printf("Usage: Pel -e EvenImage -o OddImage -r Result in shift\n");
           exit(0);
         } /* if end   */

        FptrE=fopen(EvenImage,"rt");
        if (FptrE == NULL)
         { /* if begin */
           printf("Open file error: %s\n", EvenImage);
           exit(0);
         } /* if end   */
 
	fscanf(FptrE,"%s",Buff);
        fscanf(FptrE,"%d %d %d", &Xsize,&Ysize,&i);
	ImagEven=(int *)malloc(Xsize*Ysize*sizeof(int));
	IE_F=(float *)malloc(Xsize*Ysize*sizeof(float));
 
        FptrO=fopen(OddImage,"rt");
        if (FptrO == NULL)
         { /* if begin */
           printf("Open file error: %s\n", OddImage);
           exit(0);
         } /* if end   */
 
	fscanf(FptrO,"%s",Buff);
        fscanf(FptrO,"%d %d %d", &Xsize,&Ysize,&i);

	ImagOdd=(int *)malloc(Xsize*Ysize*sizeof(int));
	IO_F=(float *)malloc(Xsize*Ysize*sizeof(float));

	MINE = MINO = 300;
	MAXE = MAXO = 0; 
        for (j=0; j<Ysize; j++)
            for (i=0; i<Xsize; i++) {
                fscanf(FptrE,"%d",&(ImagEven[j*Xsize+i]));
		MINE = (MINE >ImagEven[j*Xsize+i] ? ImagEven[j*Xsize+i]:MINE);
		MAXE = (MAXE <ImagEven[j*Xsize+i] ? ImagEven[j*Xsize+i]:MAXE);
      	    }

	/*Normalize*/
        for (j=0; j<Ysize; j++)
            for (i=0; i<Xsize; i++) 
		IE_F[j*Xsize+i] = (float) ((ImagEven[j*Xsize+i] - MINE)/
					   (MAXE - MINE));
        
        for (j=0; j<Ysize; j++)
            for (i=0; i<Xsize; i++) {
                fscanf(FptrO,"%d",&(ImagOdd[j*Xsize+i]));
		MINO = (MINO >ImagOdd[j*Xsize+i] ? ImagOdd[j*Xsize+i]:MINO);
		MAXO = (MAXO <ImagOdd[j*Xsize+i] ? ImagOdd[j*Xsize+i]:MAXO);
	    }

	/*Normalize*/
        for (j=0; j<Ysize; j++)
            for (i=0; i<Xsize; i++) 
		IO_F[j*Xsize+i] = (float) ((ImagOdd[j*Xsize+i] - MINO)/
					   (MAXO - MINO));

        FptrR=fopen(ShiftOut,"wt");
        for (j=0; j<Ysize; j++) {
            printf("----------------------------------------------\n");
	    Sign = FD (j, 0);
            if (Sign < 0) Sign = -1.0;
	    else Sign = 1.0;
            printf("++++++++++++++++++++++++++++++++++++++++++++++\n");
	    shift = D(j, 0.0, 0, 1.0);
	    if (shift < 0) dir = 0;
	    else dir = 1;
            fprintf(FptrR,"%d %d\n",dir, (int) fabs(shift));
 	}  
       fclose(FptrE);
       fclose(FptrO);
       fclose(FptrR);
}
