/* ************************************************************** */
/*                               corr.c BEGIN                     */
/* ************************************************************** */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void 	Correlation();

/* ************************************************************** */
/*                       main Begin                               */
/* ************************************************************** */
main (argc, argv)
int	argc;
char *	argv[];
{ /* main begin */
int	Xsize,X1;
int	Ysize,Y1;
char	FileName[100];
char	*end;
int	InputFlag;
FILE	*Fptr;
FILE	*FptrShift;
FILE	*FptrOdd;
FILE	*FptrEven;

int	i,j;
char	OutOdd[100];
char	OutEven[100];
char	OutShift[100];

char	buff[20];
int	Buff;
float	*Odd;
float	*Even;
float	*Shift;
int	Count;
int	MinShift;
float	Max;

       
	if (argc < 7)
         { /* if begin */
           printf("Usage: corr -o OutOdd -e OutEven -r Result<Enter>\n");
           exit(0);
         } /* if end   */
        
 	i=0; InputFlag=0;
        while (i < argc)
         { /* while begin */
              if ((strncmp(argv[i],"-r",2) == 0) && (i != (argc-1)))
               { /* if begin */
                 strcpy(FileName,argv[i+1]);
                 i=i+2;
                 InputFlag++;                   
               } /* if end   */
              else if ((strncmp(argv[i],"-o",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(OutOdd,argv[i+1]);
                 i=i+2;
                 InputFlag++;                   
               } /* else if end   */
              else if ((strncmp(argv[i],"-e",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(OutEven,argv[i+1]);
                 i=i+2;   
                 InputFlag++;                
               } /* else if end   */
              else if (1)
               { /* else if begin */
                 i++;                  
               } /* else if end   */
                 
         } /* while end   */
        if (InputFlag != 3)
         { /* if begin */
           printf("Bad input!\n");
           printf("Usage: corr -o OutOdd -e OutEven -r Result<Enter>\n");
           exit(0);
         } /* if end   */

	strcpy(OutShift,FileName);
	strcat(OutShift,".S");

        Fptr=fopen(FileName,"wt");
        FptrOdd=fopen(OutOdd,"rt");
        FptrEven=fopen(OutEven,"rt");
	FptrShift=fopen(OutShift,"wt");
        if ((Fptr == NULL) || (FptrOdd == NULL) || (FptrEven == NULL)
           || (FptrShift == NULL))
         { /* if begin */
           printf("Open file error\n");
           exit(0);
         } /* if end   */
 
	fscanf(FptrOdd,"%s",buff);
        fscanf(FptrOdd,"%d %d %d", &Xsize,&Ysize,&i);
	fscanf(FptrEven,"%s",buff);
        fscanf(FptrEven,"%d %d %d", &X1,&Y1,&i);

        if ((Xsize != X1) || (Ysize != Y1))
         { /* if begin */
           printf("There are different in size!!!\n");
           fclose(Fptr);
           fclose(FptrOdd);
           fclose(FptrEven);
	   fclose(FptrShift); 
           exit(0);
         } /* if end   */
 
	Odd=(float *)malloc(Xsize*Ysize*sizeof(float));
        Even=(float *)malloc(Xsize*Ysize*sizeof(float));
	Shift=(float *)malloc(Xsize*sizeof(float));
        if ((Odd == NULL) || (Even == NULL) || (Shift == NULL))
         { /* if begin */
           printf("Memory allocate error!!!\n");
           fclose(Fptr);
           fclose(FptrOdd);
           fclose(FptrEven); 
           exit(0);
         } /* if end   */
  
        fprintf(Fptr,"P2 \n%d %d \n%d \n",Xsize,Ysize/2,i);

        for (i=0; i<Ysize; i++)
         { /* for begin */
            for (j=0; j<Xsize; j++)
             { /* for begin */
                fscanf(FptrOdd,"%d",&(Count));
                Odd[i*Xsize+j]=(float)Count;
                fscanf(FptrEven,"%d",&(Count));
                Even[i*Xsize+j]=(float)Count;
             } /* for end   */
         } /* for end   */
	
	for (i=0; i<Ysize; i++)
         { /* for begin */
	    Correlation(Even,Odd,Shift,Xsize,i);
            Max=Shift[0]; MinShift=0;
            for (j=1; j<Xsize; j++)
             { /* for begin */
                if (Shift[j] > Max)
                 { /* if begin */
                   if (((30-j) >= 0) || ((Xsize-j) <= 30))
                    { /* if begin */ 
                      Max=Shift[j];
                      MinShift=j;
                    } /* if end   */
                 } /* if end   */
             } /* for end   */ 

            if (MinShift < (Xsize/2))
             { /* if then begin */
                fprintf(Fptr,"Line No.:%d,  Left Shift:%d, MaxCorr(Gy):%f\n",
                        i, MinShift, Max);
	        fprintf(FptrShift,"0 %d \n",MinShift);  
             } /* if then end   */
            else
             { /* if else begin */
                MinShift=Xsize-MinShift;
                fprintf(Fptr,"Line No.:%d,  Right Shift:%d, MaxCorr(Gy):%f\n",
                        i, MinShift, Max);
	        fprintf(FptrShift,"1 %d \n",MinShift); 
             } /* if else end   */
         } /* for end   */
               
        fclose(Fptr);
        fclose(FptrOdd);
        fclose(FptrEven);
	fclose(FptrShift);
	free(Odd);
        free(Even);
	free(Shift);
        printf("Program finished!\n");
} /* main end   */
/* ************************************************************** */
/*                       main End                                 */
/* ************************************************************** */

/* ************************************************************** */
/*                         Correlation Begin                      */
/* ************************************************************** */
void Correlation(X,Y,C,Num,Ptr)
float	*X;
float	*Y;
float	*C;
int	Num;
int 	Ptr;
{ /* Correlation begin */
	int 	i,j;
	float	Buff;

	for (i=0; i<Num; i++)
         { /* for begin */
            Buff=0.0;
            for (j=0; j<Num; j++)
             { /* for begin */
		if ((j-i) >= 0)
		   Buff=Buff+X[Ptr*Num+j]*Y[Ptr*Num+j-i];
                else
		   Buff=Buff+X[Ptr*Num+j]*Y[Ptr*Num+Num+j-i];
           	
             } /* for end   */
            C[i]=Buff;
         } /* for end   */
} /* Correlation end   */
/* ************************************************************** */
/*                         Correlation End                        */
/* ************************************************************** */

/* ************************************************************** */
/*                           corr.c END                           */
/* ************************************************************** */
