/* ************************************************************** */
/*                          evaluate.c BEGIN                      */
/* ************************************************************** */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* ************************************************************** */
/*                       main Begin                               */
/* ************************************************************** */
main (argc, argv)
int	argc;
char *	argv[];
{ /* main begin */
int	Xsize,X1;
int	Ysize,Y1;

char	GoodName[100];
char	BadName[100];
char	*end;
int	InputFlag;
FILE	*FptrGood;
FILE	*FptrBad;

int	i,j;
float	*Good;
float	*Bad;

char	buff[20];
int	Buff;
float	SumAbs;
float	SNR,SNRa,SNRb;
float	TotalNum;
       
	if (argc < 5)
         { /* if begin */
           printf("Usage: evaluate -g Good -b Bad <Enter>\n");
           exit(0);
         } /* if end   */
        
 	i=0; InputFlag=0;
        while (i < argc)
         { /* while begin */
              if ((strncmp(argv[i],"-g",2) == 0) && (i != (argc-1)))
               { /* if begin */
                 strcpy(GoodName,argv[i+1]);
                 i=i+2;
                 InputFlag++;                   
               } /* if end   */
              else if ((strncmp(argv[i],"-b",2) == 0) && (i != (argc-1)))
               { /* else if begin */
                 strcpy(BadName,argv[i+1]);
                 i=i+2;
                 InputFlag++;                   
               } /* else if end   */
              else if (1)
               { /* else if begin */
                 i++;                  
               } /* else if end   */
                 
         } /* while end   */
        if (InputFlag != 2)
         { /* if begin */
           printf("Bad input!\n");
           printf("Usage: evaluate -g Good -b Bad <Enter>\n"); 
           exit(0);
         } /* if end   */

        FptrGood=fopen(GoodName,"rt");
        FptrBad=fopen(BadName,"rt");
 
        if ((FptrGood == NULL) || (FptrBad == NULL))
         { /* if begin */
           printf("Open file error\n");
           exit(0);
         } /* if end   */
 
	fscanf(FptrGood,"%s",buff);
        fscanf(FptrGood,"%d %d %d", &Xsize,&Ysize,&i);
	fscanf(FptrBad,"%s",buff);
        fscanf(FptrBad,"%d %d %d", &X1,&Y1,&i);

        if ((Xsize != X1) || (Ysize != Y1))
         { /* if begin */
           printf("There are different in size!!!\n");
           fclose(FptrGood);
           fclose(FptrBad);
           exit(0);
         } /* if end   */

	Good=(float *)malloc(Xsize*Ysize*sizeof(float));
        Bad=(float *)malloc(Xsize*Ysize*sizeof(float));
	
        if ((Good == NULL) || (Bad == NULL))
         { /* if begin */
           printf("Memory allocate error!!!\n");
           fclose(FptrGood);
           fclose(FptrBad); 
           exit(0);
         } /* if end   */

        for (i=0; i<Ysize; i++)
         { /* for begin */
            for (j=0; j<Xsize; j++)
             { /* for begin */
                fscanf(FptrGood,"%d",&(Buff));
                Good[i*Xsize+j]=(float)Buff;
                fscanf(FptrBad,"%d",&(Buff));
                Bad[i*Xsize+j]=(float)Buff;
             } /* for end   */
         } /* for end   */ 
	
 	SumAbs=0.0;  SNRa=0.0;  SNRb=0.0;
        TotalNum=1.0*Xsize*Ysize;

        for (i=0; i<Ysize; i++)
         { /* for begin */
            for (j=0; j<Xsize; j++)
             { /* for begin */
                if (fabs(Good[i*Xsize+j]) != 0)
                SumAbs=SumAbs+fabs(Good[i*Xsize+j]-Bad[i*Xsize+j])
                       /(fabs(Good[i*Xsize+j]));
                SNRa=SNRa+Good[i*Xsize+j]*Good[i*Xsize+j]/TotalNum;
                SNRb=SNRb+(Good[i*Xsize+j]-Bad[i*Xsize+j])*
                     (Good[i*Xsize+j]-Bad[i*Xsize+j])/TotalNum;              
             } /* for end   */
         } /* for end   */ 

        SumAbs=SumAbs/TotalNum;
        SNR=10.0*log10(SNRa/SNRb);

        printf("Average Absolute Error Ratio: %f \n",SumAbs);
 
        printf("Signal to Noise Ration(db): %f \n",SNR);
    
        fclose(FptrGood);
        fclose(FptrBad);
        printf("Program finished!\n");
} /* main end   */
/* ************************************************************** */
/*                       main End                                 */
/* ************************************************************** */

/* ************************************************************** */
/*                          evaluate.c END                        */
/* ************************************************************** */
